<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      :message="`Les statistiques de la répartion des objets des ${followUpLabel} n'ont pas pu être chargées.`"
    />
    <template v-else-if="followUpTypeCounts">
      <h2 class="fr-h5">Objets des {{ followUpLabel }}</h2>
      <p>
        Pourcentage calculé sur le nombre total
        {{ collection === 'help_requests' ? 'de demandes' : "d'entretiens" }}
      </p>
      <StatsList
        v-if="followUpTypeCounts.length"
        :total-count="totalCount"
        :stats="followUpTypeCounts"
      />
      <p v-else>{{ emptyResultMessage }}</p>
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { COLLECTION_COLORS } from '~~/utils/constants/chart'
  import { errorResponseMessage } from '~~/utils/errorResponse'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    totalCount: {
      type: Number,
      required: true
    },
    collection: {
      type: String,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: followUpTypeCounts,
    pending,
    error
  } = useLazyAsyncData(
    `${props.collection}FollowUpTypeCounts`,
    loadFollowUpTypeCounts,
    {
      server: false,
      default: () => 0
    }
  )

  const followUpLabel = computed(() =>
    props.collection === 'help_requests' ? 'demandes' : 'entretiens'
  )

  const emptyResultMessage = computed(() => {
    return `Commencez à créer des ${
      props.collection === 'help_requests'
        ? "instructions de demande d'aides"
        : "synthèses d'entretien"
    } dans les fiches de bénéficiaires pour voir apparaître les statistiques de la répartition des objets des ${
      followUpLabel.value
    }.`
  })

  async function loadFollowUpTypeCounts() {
    // NOTE: It is not using `count` agreggation due to a Directus bug - See https://github.com/directus/directus/discussions/16992
    const res = await $getItems(props.collection, {
      fields: [
        'id',
        'follow_up_type.id',
        'follow_up_type.name',
        'follow_up_types.follow_up_types_id.id',
        'follow_up_types.follow_up_types_id.name'
      ],
      filter: props.filters
    })

    if (res.status === 200) {
      const followUpTypeResCounts = {}
      res.data.data.forEach(historyItem => {
        if (props.collection === 'help_requests') {
          if (historyItem.follow_up_type.id in followUpTypeResCounts) {
            followUpTypeResCounts[historyItem.follow_up_type.id].count++
          } else {
            followUpTypeResCounts[historyItem.follow_up_type.id] = {
              key: historyItem.follow_up_type.id,
              label: historyItem.follow_up_type.name,
              color: COLLECTION_COLORS[props.collection],
              count: 1
            }
          }
        } else {
          historyItem.follow_up_types.forEach(followUpType => {
            if (followUpType.follow_up_types_id.id in followUpTypeResCounts) {
              followUpTypeResCounts[followUpType.follow_up_types_id.id].count++
            } else {
              followUpTypeResCounts[followUpType.follow_up_types_id.id] = {
                key: followUpType.follow_up_types_id.id,
                label: followUpType.follow_up_types_id.name,
                color: COLLECTION_COLORS[props.collection],
                count: 1
              }
            }
          })
        }
      })
      const followUpTypeResCountsValues = Object.values(followUpTypeResCounts)
      followUpTypeResCountsValues.sort((a, b) => b.count - a.count)
      return followUpTypeResCountsValues
    }
    throw new Error(errorResponseMessage(res))
  }
</script>

<style scoped>
  h2 {
    word-break: break-word;
  }
</style>
